#winw=631+40+10*(11)+5+2
#winh=441
#wintitle="Mosaik"

#spr_complete=0
;icons von 1 bis 36
#spr_feld=37
#spr_ok=38
#spr_no=39
;ziffern von 40 bis 49
#spr_light=50
#spr_freestyle=51
#spr_rand=52
#spr_extreme=53

Global Dim ziffer(9)
Global Dim icons(5,5)
Global Dim feld(15,9,1)
Global Dim steine(5,5)
Global Dim hiname$(2,9)
Global Dim hiscore(2,9)

Global stein,farbe,cursx,cursy,score,badende, lightit,sound,designicon,designfeld, modi
Global loadpackmemadr
Global DisableCallback

Procedure.s MyStr(a)
  a$=Str(a)
  B$=""
  While a$<>""
    If B$
      B$="."+B$
    EndIf
    B$=Right(a$,3)+B$
    a$=Left(a$,Len(a$)-3)
  Wend
  ProcedureReturn B$
EndProcedure
  
Procedure unloadpackmem()
  If loadpackmemadr
    FreeMemory(loadpackmemadr)
    loadpackmemadr=0
  EndIf
EndProcedure
Procedure LoadPackMem(adr1)
  If loadpackmemadr
    unloadpackmem()
  EndIf
  len=PeekL(adr1):adr1+4
  loadpackmemadr=AllocateMemory(len)
  UnpackMemory(adr1,loadpackmemadr)
  ProcedureReturn loadpackmemadr
EndProcedure

Procedure loadini()
  modi=0
  sound=10
  designicon=1
  designfeld=2
  If FileSize("mosaik.dat")>0
    If ReadFile(0,"mosaik.dat")
      sound=ReadLong(0)
      designicon=ReadLong(0)
      designfeld=ReadLong(0)
      If Eof(0)=0
        modi=ReadLong(0)
      EndIf
      CloseFile(0)
    EndIf
  EndIf
EndProcedure
Procedure saveini()
  If CreateFile(0,"mosaik.dat")
    If sound<>-2
      WriteLong(0,sound)
    Else
      WriteLong(0,10)
    EndIf
    WriteLong(0,designicon)
    WriteLong(0,designfeld)
    WriteLong(0,modi)
    CloseFile(0)
  EndIf
EndProcedure
Procedure loadhiscore()
  For a=0 To 2
    For i=0 To 9
      hiname$(a,i)="GPI"
    Next
    hiscore(a,0)=1000000
    hiscore(a,1)=100000
    hiscore(a,2)=10000
    hiscore(a,3)=8000
    hiscore(a,4)=6000
    hiscore(a,5)=4000
    hiscore(a,6)=2000
    hiscore(a,7)=1000
    hiscore(a,8)=500
    hiscore(a,9)=100
  Next
  If FileSize("hiscore")>0
    If ReadFile(0,"HiScore")
      For a=0 To 2
        If Eof(0)=0
          For i=0 To 9
            hiname$(a,i)=ReadString(0)
            hiscore(a,i)=ReadLong(0)
          Next
        EndIf
      Next
      CloseFile(0)
    EndIf
  EndIf
EndProcedure
Procedure savehiscore()
  If CreateFile(0,"HiScore")
    For a=0 To 2
      For i=0 To 9
        WriteStringN(0,hiname$(a,i))
        WriteLong(0,hiscore(a,i))
      Next
    Next
    CloseFile(0)
  EndIf
EndProcedure
Procedure sorthiscore()
  For v=0 To 2
    For i=0 To 8
      For a=i+1 To 9
        If hiscore(v,i)<hiscore(v,a)
          sco=hiscore(v,i)
          nam$=hiname$(v,i)
          hiscore(v,i)=hiscore(v,a)
          hiname$(v,i)=hiname$(v,a)
          hiscore(v,a)=sco
          hiname$(v,a)=nam$
        EndIf
      Next
    Next
  Next
EndProcedure        
Procedure helpcheck2(x,y,ok)
  If feld(x,y,0) 
    If feld(x,y,0)=stein+1 :ok=1:EndIf
    If feld(x,y,1)=farbe+1 :ok=1:EndIf
  EndIf
  ProcedureReturn ok
EndProcedure
Procedure helpcheck(x,y,ok)
  If x>=0 And y>=0 And x<=15 And y<=9
    If feld(x,y,0) And ok<>0
      ok=1
      If feld(x,y,0)<>stein+1 And feld(x,y,1)<>farbe+1
        ok=0
      EndIf
    EndIf
  EndIf
  ProcedureReturn ok
EndProcedure
Procedure checkok()
  If cursx>=1 And cursx<=14 And cursy>=1 And cursy<=8
    Select modi
      Case 0
        ok=-1
        If feld(cursx,cursy,0) : ok=0 :EndIf
        ok=helpcheck(cursx-1,cursy,ok)
        ok=helpcheck(cursx+1,cursy,ok)
        ok=helpcheck(cursx,cursy-1,ok)
        ok=helpcheck(cursx,cursy+1,ok)
      Case 1
        If cursx=1 Or cursx=14 Or cursy=1 Or cursy=8
          ok=1 
        Else
          ok=0
        EndIf
        ok=helpcheck2(cursx-1,cursy,ok)
        ok=helpcheck2(cursx+1,cursy,ok)
        ok=helpcheck2(cursx,cursy-1,ok)
        ok=helpcheck2(cursx,cursy+1,ok)
        If feld(cursx,cursy,0) : ok=0 :EndIf
        If ok=-1: ok=0 :EndIf
      Case 2
        If cursx=1 Or cursx=14 Or cursy=1 Or cursy=8
          ok=1 
        Else
          ok=-1
        EndIf
        If feld(cursx,cursy,0) : ok=0 :EndIf
        ok=helpcheck(cursx-1,cursy,ok)
        ok=helpcheck(cursx+1,cursy,ok)
        ok=helpcheck(cursx,cursy-1,ok)
        ok=helpcheck(cursx,cursy+1,ok)
        If ok=-1: ok=0 :EndIf
    EndSelect
  EndIf
  ProcedureReturn ok
EndProcedure
Procedure canset()
  ok=0
  xx=cursx:yy=cursy
  For cursy=1 To 8
    For cursx=1 To 14
      If checkok() : ok=-1 :EndIf
    Next
  Next
  cursx=xx:cursy=yy
  ProcedureReturn ok
EndProcedure

Procedure loadpacksound(nr,adr)
  CatchSound(nr,LoadPackMem(adr)):unloadpackmem()
EndProcedure
Procedure loadpackspr(spr,adr)
  CatchImage(0,LoadPackMem(adr))
  unloadpackmem()
  CreateSprite(spr,ImageWidth(0),ImageHeight(0),#PB_Sprite_Memory)
  StartDrawing(SpriteOutput(spr))
  DrawImage(ImageID(0),0,0)
  StopDrawing()
  FreeImage(0)    
EndProcedure

Procedure load_icons(a)
  designicon=a
  SetMenuItemState(0,9,0)
  SetMenuItemState(0,10,0)
  SetMenuItemState(0,25,0)
  SetMenuItemState(0,26,0)
  
  Select a
    Case 1:loadpackspr(#spr_complete,?BMPicons1):SetMenuItemState(0,9,#True)
    Case 2:loadpackspr(#spr_complete,?BMPicons2):SetMenuItemState(0,10,#True)
    Case 3:loadpackspr(#spr_complete,?BMPicons3):SetMenuItemState(0,25,#True)
    Case 4:loadpackspr(#spr_complete,?BMPicons4):SetMenuItemState(0,26,#True)
  EndSelect

  i=1
  UseBuffer(#spr_complete)
  For y=0 To 5
    For x=0 To 5
      icons(x,y)=i
      GrabSprite(i,x*40,y*50,40,50)
      TransparentSpriteColor(i,RGB(255,255,255))
      i+1
    Next
  Next
  GrabSprite(#spr_no,6*40, 0 ,40,50)
  GrabSprite(#spr_ok,6*40,50 ,40,50)
  GrabSprite(#spr_light,6*40,100 ,40,50)
  FreeSprite(#spr_complete)
  UseBuffer(-1)
EndProcedure
Procedure load_ziffern()
  loadpackspr(#spr_complete,?BMPziffern)

  UseBuffer(#spr_complete)
  For i=0 To 9
    ziffer(i)=i+40
    GrabSprite(ziffer(i),i*12,0,12,22)
    TransparentSpriteColor(ziffer(i),RGB(214,82,198))
  Next
  FreeSprite(#spr_complete)
  UseBuffer(-1)
EndProcedure

Procedure load_feld(a)
  designfeld=a
  SetMenuItemState(0,5,0)
  SetMenuItemState(0,6,0)
  SetMenuItemState(0,7,0)
  SetMenuItemState(0,a+4,1) 
  
  Select a
    Case 1:loadpackspr(#spr_feld,?BMPspielfeld1)
    Case 2:loadpackspr(#spr_feld,?BMPspielfeld2)
    Case 3:loadpackspr(#spr_feld,?BMPspielfeld3)
  EndSelect
EndProcedure 

Procedure load_all()
  load_icons(designicon)
  load_ziffern()
  load_feld(designfeld)
  loadpackspr(#spr_freestyle,?BMPfreestyle)
  TransparentSpriteColor(#spr_freestyle,RGB(255,255,255))
  loadpackspr(#spr_rand,?BMPrand)
  TransparentSpriteColor(#spr_rand,RGB(255,255,255))
  loadpackspr(#spr_extreme,?BMPextreme)
  TransparentSpriteColor(#spr_extreme,RGB(255,255,255))
  
  If sound<>-2
    loadpacksound(1,?WAV1)
    loadpacksound(2,?WAV10)
    loadpacksound(3,?WAV100)
    loadpacksound(4,?WAV1000)
    loadpacksound(5,?WAVx2)
    loadpacksound(6,?WAVhiscore)
    loadpacksound(7,?WAVkeinhiscore)
    loadpacksound(8,?WAVnichtsetzen)
    loadpacksound(9,?WAVtopscore)
    loadpacksound(10,?WAVkeinplatz)
  EndIf
  
  loadhiscore()
EndProcedure
Procedure Feld_reset()
  For y=0 To 9
    For x=0 To 15
      feld(x,y,0)=0
      feld(x,y,1)=0
    Next
  Next
  For y=0 To 5
    For x=0 To 5
      steine(x,y)=2
    Next
  Next
EndProcedure
Procedure draw_screen()
  col=GetSysColor_(#COLOR_3DFACE)
  
  ;StartSpecialFX()
  
  ClearScreen(RGB(Red(col)-1,Green(col)-1,Blue(col)-1))
  ;ClearScreen(0,0,0)
  DisplaySprite(#spr_feld,0,0)
  
  xx=cursx:yy=cursy
  For y=1 To 8
    For x=1 To 14
      If feld(x,y,0) >=1
        DisplayTransparentSprite(icons(feld(x,y,0)-1,feld(x,y,1)-1),(x-1)*45+4,(y-1)*55+4)
      EndIf
      If lightit
        cursx=x:cursy=y
        If checkok()
          DisplayTransparentSprite(#spr_light,(x-1)*45+4,(y-1)*55+4)
        EndIf
      EndIf
    Next
  Next
  cursx=xx:cursy=yy
  
  For f=0 To 5
    g=631+3
    For s=0 To 5
      If steine(s,f)>=1
        DisplayTransparentSprite(icons(s,f),g,f*50+2)
        g+10
      EndIf
      If steine(s,f)>=2
        DisplayTransparentSprite(icons(s,f),g,f*50+2)
        g+10
      EndIf    
    Next
  Next
  
  If stein>=0 And farbe>=0 
    DisplayTransparentSprite(icons(stein,farbe),((#winw-631-6-40)>>1)+631+3,6*50+2+10)
  EndIf


  K=1000000000:start=10:wert=score:do=#False
  Repeat
    div=wert/K:wert%K
    If do=#False And (div>0 Or K=1)
      x=(#winw-631-6-start*12-(start/3)*4)>>1+631+3
      do=#True
    EndIf
    If do
      If start=9 Or start=6 Or start=3
        x+4
      EndIf
      DisplayTransparentSprite(ziffer(div),x,7*50+2+20)
      x+12
    EndIf
    K/10:start-1
  Until K=0 

  Select modi
    Case 0:spr=#spr_freestyle
    Case 1:spr=#spr_rand
    Case 2:spr=#spr_extreme
  EndSelect
  x=(#winw-631-6-SpriteWidth(spr))>>1+631+3
  DisplayTransparentSprite(spr,x,7*50+2+20+22+10)
  
  If cursx>=0 And cursy>=0
    If checkok()
      DisplayTranslucentSprite(#spr_ok,(cursx-1)*45+4,(cursy-1)*55+4,200)
    Else
      DisplayTranslucentSprite(#spr_no,(cursx-1)*45+4,(cursy-1)*55+4,170)
    EndIf
  EndIf

  FlipBuffers()

EndProcedure

Procedure randomstone()
  max=10; maximal 10 Versuche, um einen zuflligen stein zu finden
  Repeat
    max-1
    stein=Random(5)
    farbe=Random(5)
  Until max=0 Or steine(stein,farbe)>0
  
  ;wenn nicht, dann halt solange abzhlen, bis einer da ist
  dd=0
  While steine(stein,farbe)=0 And dd<2
    stein+1
    If stein=6
      stein=0
      farbe+1
      If farbe=6
        farbe=0:dd+1
      EndIf
    EndIf
  Wend
  If dd=2
    stein=-1:farbe=-1; tja kein stein da
  Else
    steine(stein,farbe)-1; anzahl der Steine erniedrigen
  EndIf
  
EndProcedure
Procedure newgame()
  Feld_reset()
  score=0
  badende=0
  randomstone()
EndProcedure
Procedure showhiscore()
  If IsWindow(1)=#False
    If OpenWindow(1,0,0, 220,270,"HiScore", #PB_Window_ScreenCentered|#PB_Window_SystemMenu,WindowID(0))
        PanelGadget(9,10,10,200,250)
        For a=0 To 2
          Select a
            Case 0:AddGadgetItem(9,-1,"Freestyle")
            Case 1:AddGadgetItem(9,-1,"Rand")
            Case 2:AddGadgetItem(9,-1,"Extreme")
          EndSelect
          For i=0 To 9
            TextGadget(i+10+a*30, 10,i*20+10, 100,20,hiname$(a,i))
            TextGadget(i+20+a*30,110,i*20+10,  80,20,MyStr(hiscore(a,i)),#PB_Text_Right)
          Next
          ;CloseGadgetList()
        Next
        CloseGadgetList()
        ;UseGadgetList(WindowID())
        SetGadgetState(9,modi)
     EndIf
  Else
    For a=0 To 2
      For i=0 To 9
        SetGadgetText(i+10+a*30,hiname$(a,i))
        SetGadgetText(i+20+a*30,MyStr(hiscore(a,i)))
      Next
    Next
    SetGadgetState(9,modi)
    SetActiveWindow(1)
  EndIf
EndProcedure
Procedure closehiscore()
  If WindowID(1)
    SetActiveWindow(0)
    CloseWindow(1)
  EndIf
EndProcedure
Procedure setsound(x)
  SetMenuItemState(0,14,0)
  SetMenuItemState(0,15,0)
  SetMenuItemState(0,16,0)
  SetMenuItemState(0,17,0)
  SetMenuItemState(0,18,0)
  SetMenuItemState(0,19,0)
  SetMenuItemState(0,20,0)
  SetMenuItemState(0,21,0)
  SetMenuItemState(0,22,0)
  SetMenuItemState(0,23,0)
  SetMenuItemState(0,24,0)
  SetMenuItemState(0,14+x,1)
  For i=1 To 10
    SoundVolume(i,x*10)
  Next
  sound=x
EndProcedure

Procedure MyWindowMessage(Title$,Message$)
  ok=#False
  If OpenWindow(2,0,0,302,40+5+20+5+5,title$,#PB_Window_ScreenCentered,WindowID(0))
      StringGadget(0,5,5,292,40,Message$,#ES_MULTILINE|#ES_CENTER|#ES_READONLY|#PB_String_BorderLess)
      ButtonGadget(1,5+94+5+94+5,50,94,20,"OK",#PB_Button_Default)
      AddKeyboardShortcut(2,#PB_Shortcut_Return,1)
      AddKeyboardShortcut(2,#PB_Shortcut_Escape,1)
      PlaySound_("SystemQuestion",0, #SND_ALIAS|#SND_NODEFAULT|#SND_NOWAIT |#SND_ASYNC  )
      ok=#True
  EndIf
EndProcedure
Procedure MyInput(Title$,Message$,Def$)
  ok=#False
  If OpenWindow(3,0,0,302,40+5+20+5+5,Title$,#PB_Window_ScreenCentered,WindowID(0))
      StringGadget(0,5,5,292,20,Message$,#ES_MULTILINE|#ES_CENTER|#ES_READONLY|#PB_String_BorderLess)
      StringGadget(2,5,25,292,20,Def$)
      ButtonGadget(1,5+94+5+94+5,50,94,20,"OK",#PB_Button_Default)
      AddKeyboardShortcut(3,#PB_Shortcut_Return,1)
      AddKeyboardShortcut(3,#PB_Shortcut_Escape,1)
      PlaySound_("SystemQuestion",0, #SND_ALIAS|#SND_NODEFAULT|#SND_NOWAIT |#SND_ASYNC  )
      ok=#True
      SetActiveGadget(2)
  EndIf
EndProcedure

Procedure GetWindowMouse(hWnd,*Cursor.POINT) 
  GetCursorPos_(*Cursor.POINT) 
  MapWindowPoints_(0,hWnd,*Cursor,1) 
  ProcedureReturn #True
EndProcedure 

Procedure WindowCallback(WindowID, Message, wParam, lParam)
  Result = #PB_ProcessPureBasicEvents
  If DisableCallback
    ProcedureReturn Result
  EndIf
  
  redraw=0
  If WindowID=WindowID(0)
    Select Message
;       Case #WM_MOVE:redraw=1
      Case #WM_NCPAINT:redraw=1
      Case #WM_PAINT:redraw=1
;       Case #WM_SETREDRAW:redraw=1
;       Case #WM_SHOWWINDOW:redraw=1
;       Case #WM_WINDOWPOSCHANGED:redraw=1
;       Case #WM_WINDOWPOSCHANGING:redraw=1
    EndSelect
  EndIf
  If redraw
    draw_screen()
  EndIf
  ProcedureReturn Result
EndProcedure

oldx=-1:oldy=-1
loadini()

If OpenWindow(0,0,0,#winw,#winh+MenuHeight(),#wintitle,#PB_Window_SystemMenu|#PB_Window_ScreenCentered)=0
  MessageRequester(#wintitle,"Kann kein Fenster ffnen.",0): End
EndIf

CreateMenu(0,WindowID(0))
MenuTitle("Mosaik")
OpenSubMenu("New Game")
MenuItem(1,"Freestyle")
MenuItem(12,"Rand")
MenuItem(13,"Extreme")
CloseSubMenu()
MenuBar()
If sound=-2
  MenuItem(11,"Sound")
  DisableMenuItem(0,11,1)
Else
  OpenSubMenu("Sound")
  MenuItem(14,"off")
  MenuItem(15," 10%")
  MenuItem(16," 20%")
  MenuItem(17," 30%")
  MenuItem(18," 40%")
  MenuItem(19," 50%")
  MenuItem(20," 60%")
  MenuItem(21," 70%")
  MenuItem(22," 80%")
  MenuItem(23," 90%")
  MenuItem(24,"100%")
  CloseSubMenu()
EndIf
MenuBar()
MenuItem(2,"Highscores")
MenuBar()
MenuItem(3,"Quit")
MenuTitle("Style")
MenuItem(5,"Field 1")
MenuItem(6,"Field 2")
MenuItem(7,"Field 3")
MenuBar()
MenuItem(9,"Stone A")
MenuItem(10,"Stone B")
MenuItem(25,"Stone C")
MenuItem(26,"Stone D")
MenuTitle("Help")
MenuItem(8,"About...")
MenuBar()
MenuItem(4,"Where can I set the stone?")

If InitSprite()=0
  MessageRequester(#wintitle,"Kann DirectX nicht ffnen",0):End
EndIf

If OpenWindowedScreen(WindowID(0),0,2,#winw,#winh,#False,0,0)=0
  MessageRequester(#wintitle,"Kann Grafik nicht initalisieren",0):End
EndIf

If InitSound()=0
  ;MessageRequester(#wintitle,"Kann Sound-System nicht initalisieren",0):End
  sound=-2
EndIf

Frame3DGadget(0, 0,0,#winw,2,"",#PB_Frame3D_Single)
; TextGadget(0,0,0,#winw,#winh,"");Dummy-Gadget, um die Position zu bestimmen.
; HideGadget(0,1)
; DisableGadget(0,1)

       
load_all()
If sound<>-2 :setsound(sound):EndIf

newgame()

quit=0
delayTimer=GetTickCount_()
#delayTimer=40

SetWindowCallback(@WindowCallback())

Repeat
  eventid=WaitWindowEvent()
   
  If IsWindow(1)=0 And IsWindow(2)=0 And IsWindow(3)=0 And GetActiveWindow_()=WindowID(0)
    GetWindowMouse(WindowID(0),maus.POINT)
    x=maus\x:y=maus\y-2
    cursx=-1:cursy=-1
                    
    If x>=0 And y>=0 And x=<631 And y=<441
      x=Int(Round((x-1)/45,0))+1:y=Int(Round((y-1)/55,0))+1
      If x>=1 And x<=14 And y>=1 And y<=8
        cursx=x:cursy=y
      EndIf          
    EndIf
  Else
    cursx=-1:cursy=-1
  EndIf 
  
  If cursx<>oldx Or cursy<>oldy
    oldx=cursx:oldy=cursy
  EndIf
  
  playsound=0
  
  If eventid
    Select EventWindow()
      Case 0; hauptfenster
        Select eventid
          Case #PB_Event_Menu
            Select EventMenu()
              Case 1:modi=0:newgame()
              Case 12:modi=1:newgame()
              Case 13:modi=2:newgame()
              Case 2:showhiscore()
              Case 3:quit=1
              Case 4:lightit=1:
              Case 8:MyWindowMessage(#wintitle,"Mosaik"+Chr(13)+Chr(10)+"GPI "+FormatDate("%DD.%mm.%yyyy",#PB_Compiler_Date))
              Case 9:load_icons(1)
              Case 10:load_icons(2)
              Case 25:load_icons(3)
              Case 26:load_icons(4)
              ;Case 11:sound=1-sound:SetMenuItemState(0,11,1-sound)
              Default
                i=EventMenu()-4
                If i>=1 And i<=3
                  ;FreeSprite(#spr_feld)
                  ;LoadSprite(#spr_feld,"Spielfeld"+Str(i)+".bmp")
                  load_feld(i)
                EndIf
                i=EventMenu()-14
                If i>=0 And i<=10
                  setsound(i)
                EndIf
            EndSelect
          Case #WM_LBUTTONDOWN
            lightit=0
            If cursx>=1 And cursx<=14 And cursy>=1 And cursy<=8
              If checkok()
                feld(cursx,cursy,0)=stein+1
                feld(cursx,cursy,1)=farbe+1
                
                nachbarn=0
                If feld(cursx-1,cursy,0)>0:nachbarn+1:EndIf
                If feld(cursx+1,cursy,0)>0:nachbarn+1:EndIf
                If feld(cursx,cursy-1,0)>0:nachbarn+1:EndIf
                If feld(cursx,cursy+1,0)>0:nachbarn+1:EndIf
                Select nachbarn
                  Case 0:score+1
                  Case 1:score+5
                  Case 2:score+10
                  Case 3:score+50
                  Case 4:score*2
                EndSelect
                playsound=nachbarn+1
                
                randomstone()
              Else
                playsound=8
              EndIf
            EndIf
          Case #PB_Event_CloseWindow :quit=1
        EndSelect
      Case 1
        If eventid=#PB_Event_CloseWindow
          closehiscore()
        EndIf
      Case 2
        ok=#False
        Select eventid
          Case #PB_Event_CloseWindow:ok=#True
          Case #PB_Event_Gadget:If EventGadget()=1 :ok=#True: EndIf
          Case #PB_Event_Menu:If EventMenu()=1 : ok=#True : EndIf
        EndSelect
        If ok
          CloseWindow(2)
          If WaitForEndMessage
            newgame()
            showhiscore()
            WaitForEndMessage=0
          EndIf
        EndIf
      Case 3
        ok=#False
        Select eventid
          Case #PB_Event_CloseWindow:ok=#True
          Case #PB_Event_Gadget:If EventGadget()=1 :ok=#True: EndIf
          Case #PB_Event_Menu:If EventMenu()=1 : ok=#True : EndIf
        EndSelect
        If ok
          hiname$(modi,9)=GetGadgetText(2)
          hiscore(modi,9)=score
          CloseWindow(3)
          sorthiscore()
          newgame()
          showhiscore()
        EndIf
    EndSelect
  EndIf
  
  a=GetTickCount_()
  If delayTimer<a
    delayTimer+#delayTimer
    If delayTimer+#delayTimer<a
      delayTimer=a+#delayTimer
    EndIf
    draw_screen()
  ElseIf eventid=0
    Delay(1) 
  EndIf

  If IsWindow(3)=0 And WaitForEndMessage=0
    If canset()=0 : badende=1: EndIf
    
    If stein=-1 Or badende=1
      
      If hiscore(modi,9)<score
        If hiscore(modi,0)<score : playsound=9:T$="TopScore" :Else: playsound=6:T$="HiScore" :EndIf
        If sound: PlaySound(playsound) :EndIf
        playsound=0
        MyInput(#wintitle,"A New "+T$+"!","GPI")
      Else
        If badende<>0: playsound=10 :Else: playsound=7 :EndIf
        If sound: PlaySound(playsound) :EndIf
        playsound=0
        MyWindowMessage(#wintitle,"Game Over"+Chr(13)+Chr(10)+"Your Score:"+MyStr(score))
        WaitForEndMessage=#True
      EndIf
    EndIf
  EndIf

  If playsound
    If sound: PlaySound(playsound) :playsound=0:EndIf
  EndIf  
Until quit

DisableCallback=#True          

CloseScreen()
CloseWindow(0)
savehiscore()  
saveini()
End
DataSection
BMPfreestyle:
IncludeBinary "data\freestyle.bmp.pck"
BMPrand:
IncludeBinary "data\rand.bmp.pck"
BMPextreme:
IncludeBinary "data\extreme.bmp.pck"
BMPicons1:
IncludeBinary "data\icons1.bmp.pck"
BMPicons2:
IncludeBinary "data\icons2.bmp.pck"
BMPicons3:
IncludeBinary "data\icons3.bmp.pck"
BMPicons4:
IncludeBinary "data\icons4.bmp.pck"
BMPspielfeld1:
IncludeBinary "data\spielfeld1.bmp.pck"
BMPspielfeld2:
IncludeBinary "data\spielfeld2.bmp.pck"
BMPspielfeld3:
IncludeBinary "data\spielfeld3.bmp.pck"
BMPziffern:
IncludeBinary "data\ziffern.bmp.pck"
WAVx2:
IncludeBinary "data\x2.wav.pck"
WAVtopscore:
IncludeBinary "data\topscore.wav.pck"
WAVnichtsetzen:
IncludeBinary "data\nichtsetzen.wav.pck"
WAVkeinplatz:
IncludeBinary "data\keinplatz.wav.pck"
WAVkeinhiscore:
IncludeBinary "data\keinhiscore.wav.pck"
WAVhiscore:
IncludeBinary "data\hiscore.wav.pck"
WAV1:
IncludeBinary "data\1.wav.pck"
WAV10:
IncludeBinary "data\10.wav.pck"
WAV100:
IncludeBinary "data\100.wav.pck"
WAV1000:
IncludeBinary "data\1000.wav.pck"
EndDataSection
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 731
; FirstLine = 728
; Folding = -----
; CurrentDirectory = ..\exe\